=== debian/changelog ===
mailio (0.23.0-1) unstable; urgency=medium

  * Initial release

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 16 Apr 2024 23:44:04 +0200
