## mailio 0.23.0+git20241012.8821f91

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,9 @@
 cmake_minimum_required (VERSION 3.16.3)
 
-project(mailio VERSION 0.23.0)
+project(mailio VERSION 0.24.0)
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
 if(NOT DEFINED LIB_SUFFIX)
   set(LIB_SUFFIX "" CACHE STRING "Suffix for installed library path. Ex. 64 for lib64")
@@ -47,9 +48,10 @@
 # options for mailio to control how the project is built.
 option(MAILIO_BUILD_DOCUMENTATION "Turn on to build doxygen based documentation." ON)
 option(MAILIO_BUILD_EXAMPLES "Turn on to build examples." ON)
-option(MAILIO_BUILD_SHARED_LIBRARY "Turn on to build the shared library." ON)
 option(MAILIO_BUILD_TESTS "Turn on to build the tests." ON)
 option(MAILIO_DYN_LINK_TESTS "Turn on to dynamically link the tests." OFF)
+
+option(BUILD_SHARED_LIBS "Turn on to build mailio as a shared library. When off mailio is build as a static library." ON)
 
 # add a dependent option to build latex documentation or not.
 include(CMakeDependentOption)
@@ -59,7 +61,7 @@
     set(Boost_USE_STATIC_LIBS ON)
 endif(WIN32)
 
-find_package(Boost REQUIRED COMPONENTS system date_time regex unit_test_framework)
+find_package(Boost REQUIRED COMPONENTS system date_time regex)
 find_package(OpenSSL)
 set(CMAKE_THREAD_PREFER_PTHREAD)
 # "Use of both the imported target as well as this switch is highly recommended for new code."
@@ -77,6 +79,7 @@
     ${PROJECT_SOURCE_DIR}/src/mailboxes.cpp
     ${PROJECT_SOURCE_DIR}/src/message.cpp
     ${PROJECT_SOURCE_DIR}/src/mime.cpp
+    ${PROJECT_SOURCE_DIR}/src/percent.cpp
     ${PROJECT_SOURCE_DIR}/src/pop3.cpp
     ${PROJECT_SOURCE_DIR}/src/quoted_printable.cpp
     ${PROJECT_SOURCE_DIR}/src/q_codec.cpp
@@ -94,6 +97,7 @@
     ${PROJECT_SOURCE_DIR}/include/mailio/mailboxes.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/message.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/mime.hpp
+    ${PROJECT_SOURCE_DIR}/include/mailio/percent.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/pop3.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/quoted_printable.hpp
     ${PROJECT_SOURCE_DIR}/include/mailio/q_codec.hpp
@@ -117,13 +121,7 @@
     endif(DOXYGEN_FOUND)
 endif(${MAILIO_BUILD_DOCUMENTATION})
 
-set(LIBRARY_TYPE, "")
-if (MAILIO_BUILD_SHARED_LIBRARY)
-    set(LIBRARY_TYPE "SHARED")
-else()
-    set(LIBRARY_TYPE "STATIC")
-endif()
-add_library(${PROJECT_NAME} ${LIBRARY_TYPE} ${project_sources} ${project_headers})
+add_library(${PROJECT_NAME} ${project_sources} ${project_headers})
 
 
 # pkg-config support
