=== debian/changelog ===
mailio (0.23.0+git20241012.8821f91-1) unstable; urgency=medium

  * New upstream release.

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 13 Oct 2024 22:03:29 +0200
