=== debian/control ===
Source: mailio
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13)
	, cmake
	, libboost-date-time-dev
	, libboost-regex-dev
	, libboost-system-dev
	, libboost-test-dev
	, libssl-dev
Standards-Version: 4.7.0
Section: libs
Homepage: https://github.com/karastojko/mailio
Vcs-Browser: https://salsa.debian.org/alteholz/mailio
Vcs-Git: https://salsa.debian.org/alteholz/mailio.git
Rules-Requires-Root: no

Package: mailio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmailio1 (= ${binary:Version}), ${misc:Depends}
Description: cross platform C++ library for email support (development)
 mailio is a cross platform C++ library for MIME format and SMTP, POP3
 and IMAP protocols.
 .
 It is based on the standard C++ 17 and Boost library.
 .
 This package contains the development files.

Package: libmailio1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: cross platform C++ library for email support (library)
 mailio is a cross platform C++ library for MIME format and SMTP, POP3
 and IMAP protocols.
 .
 It is based on the standard C++ 17 and Boost library.
 .
 This package contains the library.
