=== debian/changelog ===
mailio (0.25.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: bump standard to 4.7.2 (no changes)
  * bump soname to 2

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 17 Aug 2025 10:00:47 +0200
