=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	, libboost-system-dev
 	, libboost-test-dev
 	, libssl-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/karastojko/mailio
 Vcs-Browser: https://salsa.debian.org/alteholz/mailio
@@ -19,7 +19,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmailio1 (= ${binary:Version}), ${misc:Depends}
+Depends: libmailio2 (= ${binary:Version}), ${misc:Depends}
 Description: cross platform C++ library for email support (development)
  mailio is a cross platform C++ library for MIME format and SMTP, POP3
  and IMAP protocols.
@@ -28,7 +28,7 @@
  .
  This package contains the development files.
 
-Package: libmailio1
+Package: libmailio2
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
