=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,10 @@
 %:
 	dh $@
 
+override_dh_install:
+	find
+	dh_install
+
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DMAILIO_BUILD_SHARED_LIBRARY=ON
