=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libahp-gt-$1\.tar\.gz/ \
  https://github.com/karastojko/mailio/tags .*/v?(\d\S+)\.tar\.gz \
  debian uupdate
